//+---------------------------------------------------------------------------------+
//|                                                          LimitNet+Stop^atom.mq4 |
//|                                                                           Verdi |
//|                                                                 nemo811@mail.ru |
//|     limit-   .   |
//| :    ( atom).     |
//| Lot        buy  sell  |
//|;    .  Lot, R_Lot  R_point       |
//|    .   Lot limit-|
//|   . takeprofit         |
//|    0.      -     |
//|              |
//|takeprofit!   Limit-  Stop- (TP,SL,Magic = 0)     |
//|  . R_Lot  R_point     |
//|(!)(!)  .                                                  |
//|                |
//|   .                                                       |
//|      :                            |
//| -   1  = 1 : 10 000                                          |
//| -    = 4%                                                          |
//| -   1     0.1  = 37 .                     |
//| -    = 150 .                                           |
//+---------------------------------------------------------------------------------+
#property copyright "Verdi"
#property link      "nemo811@mail.ru"
#property show_inputs
//--------------------------------------------------------------------
extern bool    atom        = true;   //./.  
extern int     Magic       = 0;      //    ( Stop-)
extern bool    BUY         = false;  //  BUY    BUY LIMIT
extern bool    SELL        = false;  //  SELL    SELL LIMIT
extern double  Lot         = 0.1;    //     limit- (  )
extern int     delta       = 37;     // 
extern int     MaxOrders   = 2;      //- limit- 
extern int     takeprofit  = 50;     //  TP,  0,  TP   zero_tp               
extern int     stoploss    = 0;      //  SL,  0,  SL  
extern string  corr=" ";
extern int     zero_tp     = 1;      //  takeprofit      0,  0,
                                     // takeprofit    (!) 1  0(!)
extern int     R_Lot       = 1;      //  Lot    (!)(!)  ,  0 -
                                     //  +  R_point,   Lot: R_Lot*Lot=   
extern int     R_point     = 37;     // Loss     (!)(!),  0 -   
//--------------------------------------------------------------------
double SL,TP,Price,Price_U,Sum,DeltaProfitR,DeltaProfitL,LotR,LotL,LotS,Balans,Free;
//--------------------------------------------------------------------
int start()
{
 if (atom)
 {
  int f=OrdersTotal();
  if (f<1)
  {  
   for (int xx=1; xx<=1; xx++)
   {
      if (BUY)
      {
         LotR=Lot;
         if (takeprofit!=0) TP  = NormalizeDouble(Bid + takeprofit*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Bid - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy",Price,SL,TP,xx);
      }
      if (SELL)
      {  
         LotR=Lot;
         if (takeprofit!=0) TP = NormalizeDouble(Ask - takeprofit*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Ask + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell",Price,SL,TP,xx);
      }
   }
   double Sumi=0;
   for (int ii=1; ii<=MaxOrders; ii++)
   {
      if (BUY)
      {
         LotL=Lot*ii;
         Price = NormalizeDouble(Ask-delta*ii*Point,Digits);
         Price_U = NormalizeDouble(Bid-delta*ii*Point,Digits);
         Sumi=Sumi+delta*(2*Lot+Lot*(ii-2))*(ii-1)/2;
         DeltaProfitL = (Sumi+ii*delta*Lot)/((2*Lot+Lot*(ii-1))*ii/2+Lot);
         if (takeprofit!=0) TP  = NormalizeDouble(Price_U + (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Price_U - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy Limit",Price,SL,TP,ii);
      }
      if (SELL)
      {  
         LotL=Lot*ii;     
         Price = NormalizeDouble(Bid+delta*ii*Point,Digits);
         Price_U = NormalizeDouble(Ask+delta*ii*Point,Digits);
         Sumi=Sumi+delta*(2*Lot+Lot*(ii-2))*(ii-1)/2;
         DeltaProfitL = (Sumi+ii*delta*Lot)/((2*Lot+Lot*(ii-1))*ii/2+Lot);
         if (takeprofit!=0) TP = NormalizeDouble(Price_U - (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Price_U + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell Limit",Price,SL,TP,ii);
      }
   }
   for (int vv=1; vv<=1; vv++)
   {
      if (BUY)
      {
         LotS=(2*Lot+Lot*(MaxOrders-1))*MaxOrders/2+Lot;
         OPENORDER ("Sell Stop",Price,SL,TP,vv);
      }
      if (SELL)
      {  
         LotS=(2*Lot+Lot*(MaxOrders-1))*MaxOrders/2+Lot;
         OPENORDER ("Buy Stop",Price,SL,TP,vv);
      }
   }   
  }
  else
  {  
   Balans=AccountBalance();
   Free=AccountEquity();
   
   double SchBuyLs=SchBuyLs_b();
   double SchSellLs=SchSellLs_b(); 
   double dx=SchBuyLs-SchSellLs, dy;
   dy=MathAbs(dx);

   double ad.QuotePoint = MarketInfo(Symbol(), MODE_POINT);
   double ad.QuoteTick = MarketInfo(Symbol(), MODE_TICKSIZE);
   double ad.NominalTick = MarketInfo(Symbol(), MODE_TICKVALUE);
   double ad.NominalPoint = ad.NominalTick  * ad.QuotePoint / ad.QuoteTick ;  
   
   double n=(Balans-Free)/ad.NominalPoint; 
 
    for (int xxx=1; xxx<=1; xxx++)
   {
      DeltaProfitR = n/(dy+dy);
      if (BUY)
      {
         LotR=dy;
         if (takeprofit!=0) TP  = NormalizeDouble(Bid + (takeprofit+DeltaProfitR*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Bid - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy",Price,SL,TP,xxx);
      }
      if (SELL)
      {  
         LotR=dy;
         if (takeprofit!=0) TP = NormalizeDouble(Ask - (takeprofit+DeltaProfitR*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Ask + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell",Price,SL,TP,xxx);
      }
   }
   double Sumii=0;
   for (int iii=1; iii<=MaxOrders; iii++)
   {
      if (BUY)
      {
         LotL=dy*iii;
         Price = NormalizeDouble(Ask-delta*iii*Point,Digits);
         Price_U = NormalizeDouble(Bid-delta*iii*Point,Digits);
         Sumii=Sumii+delta*(2*dy+dy*(iii-2))*(iii-1)/2;
         DeltaProfitL = (Sumii+iii*delta*dy+dy*n+dy*delta*iii)/((2*dy+dy*(iii-1))*iii/2+dy+dy);
         if (takeprofit!=0) TP  = NormalizeDouble(Price_U + (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Price_U - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy Limit",Price,SL,TP,iii);
      }
      if (SELL)
      {  
         LotL=dy*iii;  
         Price = NormalizeDouble(Bid+delta*iii*Point,Digits);
         Price_U = NormalizeDouble(Ask+delta*iii*Point,Digits);
         Sumii=Sumii+delta*(2*dy+dy*(iii-2))*(iii-1)/2;
         DeltaProfitL = (Sumii+iii*delta*dy+dy*n+dy*delta*iii)/((2*dy+dy*(iii-1))*iii/2+dy+dy);
         if (takeprofit!=0) TP = NormalizeDouble(Price_U - (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Price_U + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell Limit",Price,SL,TP,iii);
      }
   }
   for (int vvv=1; vvv<=1; vvv++)
   {
      if (BUY)
      {
         LotS=(2*dy+dy*(MaxOrders-1))*MaxOrders/2+dy+dy;
         OPENORDER ("Sell Stop",Price,SL,TP,vvv);
      }
      if (SELL)
      {  
         LotS=(2*dy+dy*(MaxOrders-1))*MaxOrders/2+dy+dy;
         OPENORDER ("Buy Stop",Price,SL,TP,vvv);
      }
   }
 
 
  
  
  }
 }
 else
 {
   for (int x=1; x<=1; x++)
   {
      DeltaProfitR = (Lot*R_Lot*R_point)/(Lot+Lot*R_Lot);
      if (BUY)
      {
         LotR=Lot;
         if (takeprofit!=0) TP  = NormalizeDouble(Bid + (takeprofit+DeltaProfitR*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Bid - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy",Price,SL,TP,x);
      }
      if (SELL)
      {  
         LotR=Lot;
         if (takeprofit!=0) TP = NormalizeDouble(Ask - (takeprofit+DeltaProfitR*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Ask + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell",Price,SL,TP,x);
      }
   }
   double Sum=0;
   for (int i=1; i<=MaxOrders; i++)
   {
      if (BUY)
      {
         LotL=Lot*i;
         Price = NormalizeDouble(Ask-delta*i*Point,Digits);
         Price_U = NormalizeDouble(Bid-delta*i*Point,Digits);
         Sum=Sum+delta*(2*Lot+Lot*(i-2))*(i-1)/2;
         DeltaProfitL = (Sum+i*delta*Lot+Lot*R_Lot*R_point+Lot*R_Lot*delta*i)/((2*Lot+Lot*(i-1))*i/2+Lot+Lot*R_Lot);
         if (takeprofit!=0) TP  = NormalizeDouble(Price_U + (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Price_U - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy Limit",Price,SL,TP,i);
      }
      if (SELL)
      {  
         LotL=Lot*i;     
         Price = NormalizeDouble(Bid+delta*i*Point,Digits);
         Price_U = NormalizeDouble(Ask+delta*i*Point,Digits);
         Sum=Sum+delta*(2*Lot+Lot*(i-2))*(i-1)/2;
         DeltaProfitL = (Sum+i*delta*Lot+Lot*R_Lot*R_point+Lot*R_Lot*delta*i)/((2*Lot+Lot*(i-1))*i/2+Lot+Lot*R_Lot);
         if (takeprofit!=0) TP = NormalizeDouble(Price_U - (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Price_U + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell Limit",Price,SL,TP,i);
      }
   }
   for (int v=1; v<=1; v++)
   {
      if (BUY)
      {
         LotS=(2*Lot+Lot*(MaxOrders-1))*MaxOrders/2+Lot+Lot*R_Lot;
         OPENORDER ("Sell Stop",Price,SL,TP,v);
      }
      if (SELL)
      {  
         LotS=(2*Lot+Lot*(MaxOrders-1))*MaxOrders/2+Lot+Lot*R_Lot;
         OPENORDER ("Buy Stop",Price,SL,TP,v);
      }
   }
 }
return(0);
}
//---------------------------------------------------------------------------
    double SchBuyLs_b() {
      double SchBuyLs=0;
      int w;
      string SMBB=Symbol();
      for (w=OrdersTotal()-1;w>=0;w--) {
        if (!OrderSelect(w, SELECT_BY_POS, MODE_TRADES)) {ShowERROR();}
        else{
         if(OrderSymbol()!= SMBB) continue;
         if(OrderType()==OP_BUY) {
          SchBuyLs=SchBuyLs+OrderLots();
         }
        }
       }
     return(SchBuyLs);
    }
//---------------------------------------------------------------------------
    double SchSellLs_b() {
      double SchSellLs=0;
      int d;
      string SMBL=Symbol();
      for (d=OrdersTotal()-1;d>=0;d--) {
       if (!OrderSelect(d, SELECT_BY_POS, MODE_TRADES)) {ShowERROR();}
       else{
        if(OrderSymbol()!= SMBL) continue;
        if(OrderType()==OP_SELL) {
         SchSellLs=SchSellLs+OrderLots();
       }
      }
     }
     return(SchSellLs);
    }
//-----------------------------------------------------------------------------
void OPENORDER(string ord,double Price,double SL,double TP,int i)
{
   int ticket = -1;
   int err;
   while (ticket<0)
   {
      if (ord=="Buy") ticket=OrderSend(Symbol(),OP_BUY,LotR,NormalizeDouble(Ask,Digits),3,SL,TP,"Magic_" + Magic,Magic,0);
      if (ord=="Sell") ticket=OrderSend(Symbol(),OP_SELL,LotR,NormalizeDouble(Bid,Digits),3,SL,TP,"Magic_" + Magic,Magic,0);
      if (ord=="Buy Limit") ticket=OrderSend(Symbol(),OP_BUYLIMIT,LotL,Price,3,SL,TP,StringConcatenate(""+i,"  Magic_" + Magic),Magic,0);
      if (ord=="Sell Limit") ticket=OrderSend(Symbol(),OP_SELLLIMIT,LotL,Price,3,SL,TP,StringConcatenate(""+i,"  Magic_" + Magic),Magic,0);
      if (ord=="Buy Stop") ticket=OrderSend(Symbol(),OP_BUYSTOP,LotS,NormalizeDouble(Ask+delta*(MaxOrders+1)*Point,Digits),3,0,0,"Lock, Magic_0",0,0);
      if (ord=="Sell Stop") ticket=OrderSend(Symbol(),OP_SELLSTOP,LotS,NormalizeDouble(Bid-delta*(MaxOrders+1)*Point,Digits),3,0,0,"Lock, Magic_0",0,0);
      Message(Magic);
      if (ticket==-1)
      {  
         ShowERROR();
         err++;Sleep(2000);RefreshRates();
      }
      if (ticket!=-1 || err >10) return;
   }
return;
}                  
//--------------------------------------------------------------------
void Message(string Magic) {
  Comment("Magic_" + Magic);
  Print("Magic_" + Magic);
}                                      
//--------------------------------------------------------------------
void ShowERROR()
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:   return;
      case 2:   Alert("     ",Symbol());return;
      case 3:   Alert("Error   ",Symbol());return;
      case 130: Alert("Error     Ticket ",Symbol());return;
      case 134: Alert("    ",Symbol());return;
      case 146: Alert("Error    ",Symbol());return;
      case 129: Alert("Error   ",Symbol());return;
      case 131: Alert("Error   ",Symbol());return;
      default:  Alert("Error  " ,err," ",Symbol());return;
   }
}
//+--------------------------------------------------------------------+

